unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    ResultEdit: TEdit;
    CalculateButton: TButton;
    CopyButton: TButton;
    ExitButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure CopyButtonClick(Sender: TObject);
    procedure CalculateButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    Function  FillZero(S : String; Len : Integer) : String;      //1:12:3 => 01:12:03
    procedure CleanUp;
    function Calculate():string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{*error handling required(check for letters)
 *auto fill missing zeros(1:1:3:1 -> 01:01:03:100)
 *ablility to use space as time separator (:) }

procedure TForm1.CleanUp;
var  I,J,K : integer;
     currentLine,hours,mins,secs,msecs:string;
begin{
  for I := 0 to Memo1.Lines.Count-1 do begin
    currentLine := Memo1.Lines.Strings[I];
    J := 0;
    K := 0;
    while J <= Length(CurrentLine)-1 do
    begin
      J := CurrentLine(I);
      if (J = ':') or (J = ' ') or (J = '_') or (J = ';') then
        hours :=
    end;


  //do this

  end;}
end;

function TForm1.Calculate:string;                      //example time used: 01:23:45:678
var I,hours,minutes,seconds,milliseconds,millisecondstotal : integer;       //I = current line
  currentLine, temp : string;
begin
  millisecondstotal := 0;
  temp := '';
  for I := 0 to Memo1.Lines.Count-1 do begin
    currentLine := Memo1.Lines.Strings[I];           //returns 01:23:45:678

    temp := AnsiMidStr(currentLine,1,2);             //returns 01     //AnsiMidStr :Returns the substring of a specified length that appears at a specified position in a string.
    inc(millisecondstotal,strToInt(temp)*60*60*1000);

    temp := AnsiMidStr(currentLine,4,2);             //returns 23
    inc(millisecondstotal,strToInt(temp)*60*1000);

    temp := AnsiMidStr(currentLine,7,2);             //returns 45
    inc(millisecondstotal,strToInt(temp)*1000);

    temp := AnsiMidStr(currentLine,10,3);            //returns 678
    inc(millisecondstotal,strToInt(temp));
  end;
  hours := millisecondstotal div (1000*60*60);
  minutes := (millisecondstotal mod (1000*60*60)) div (1000*60);
  seconds := (millisecondstotal mod (1000*60)) div 1000;
  milliseconds := (millisecondstotal mod 1000) mod 1000;

  result := FillZero(IntToStr(hours),2)+':'+FillZero(IntToStr(minutes),2)+':'+FillZero(IntToStr(seconds),2)+':'+FillZero(IntToStr(milliseconds),3);
end;

function TForm1.FillZero(S : String; Len : Integer) : String;                          //Fills empty spaces with zeros(4 -> 04)
begin
  While Length(S) < Len do
    S := '0'+S;
  Result := S;
end;

procedure TForm1.CopyButtonClick(Sender: TObject);
begin
  ResultEdit.SelectAll;
  ResultEdit.CopyToClipboard;
  ResultEdit.SelLength := 0;
end;

procedure TForm1.CalculateButtonClick(Sender: TObject);
var I : integer;
begin
  ResultEdit.Text := Calculate;
end;

procedure TForm1.ExitButtonClick(Sender: TObject);
begin
  Close();
end;

function FillZero(S : String; Len : Integer) : String;                          //Fills empty spaces with zeros(4 -> 04)
begin
  While Length(S) < Len do S := '0'+S;
  Result := S;
end;

end.

